package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.StoreInfo;
import com.izouma.awesomeadmin.service.StoreInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/storeInfo")
@RequiresAuthentication
public class StoreInfoController {

    @Autowired
    private StoreInfoService storeInfoService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(StoreInfo record) {
        List<StoreInfo> pp = storeInfoService.getStoreInfoList(record);
        return new Result(true, pp);
    }

    @RequiresAuthentication
    @RequestMapping(value = "/home", method = RequestMethod.GET)
    @ResponseBody
    public Result home(StoreInfo record) {
        List<StoreInfo> pp = storeInfoService.getStoreInfoListForHome(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getStoreInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getStoreInfo(@RequestParam(required = false, value = "id") String id) {
        StoreInfo data = storeInfoService.getStoreInfoById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(StoreInfo record) {
        StoreInfo data = storeInfoService.getStoreInfo(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, StoreInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<StoreInfo> pp = storeInfoService.getStoreInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(StoreInfo record) {
        boolean num = storeInfoService.createStoreInfo(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateStoreInfo(StoreInfo record) {
        boolean num = storeInfoService.updateStoreInfo(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteStoreInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = storeInfoService.deleteStoreInfo(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, StoreInfo record) throws Exception {

        List<StoreInfo> storeInfos = storeInfoService.getStoreInfoList(record);


        String sheetName = "store_info";
        String titleName = "店铺信息数据表";
        String fileName = "店铺信息表";
        int columnNumber = 28;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "用户ID", "用户", "店铺名称", "服务类型", "描述", "头像", "省", "市", "区", "详细地址", "银行卡号", "开户行", "开户人", "信誉等级", "可用", "排序", "响应时间", "返片率", "热门", "首页", "类型", "服务小类"};
        String[][] dataList = new String[storeInfos.size()][28];

        for (int i = 0; i < storeInfos.size(); i++) {

            dataList[i][0] = String.valueOf(storeInfos.get(i).getId());
            dataList[i][1] = String.valueOf(storeInfos.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(storeInfos.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(storeInfos.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(storeInfos.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(storeInfos.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(storeInfos.get(i).getUserId());
            dataList[i][7] = String.valueOf(storeInfos.get(i).getUserName());
            dataList[i][8] = String.valueOf(storeInfos.get(i).getStoreName());
            dataList[i][9] = String.valueOf(storeInfos.get(i).getServiceType());
            dataList[i][10] = String.valueOf(storeInfos.get(i).getDescription());
            dataList[i][11] = String.valueOf(storeInfos.get(i).getIcon());
            dataList[i][12] = String.valueOf(storeInfos.get(i).getProvince());
            dataList[i][13] = String.valueOf(storeInfos.get(i).getCitye());
            dataList[i][14] = String.valueOf(storeInfos.get(i).getDistrict());
            dataList[i][15] = String.valueOf(storeInfos.get(i).getAddressDetail());
            dataList[i][16] = String.valueOf(storeInfos.get(i).getBankCard());
            dataList[i][17] = String.valueOf(storeInfos.get(i).getBankName());
            dataList[i][18] = String.valueOf(storeInfos.get(i).getOpenName());
            dataList[i][19] = String.valueOf(storeInfos.get(i).getCredit());
            dataList[i][20] = String.valueOf(storeInfos.get(i).getUseFlag());
            dataList[i][21] = String.valueOf(storeInfos.get(i).getRank());
            dataList[i][22] = String.valueOf(storeInfos.get(i).getResponseTime());
            dataList[i][23] = String.valueOf(storeInfos.get(i).getReworkRate());
            dataList[i][24] = String.valueOf(storeInfos.get(i).getHotFlag());
            dataList[i][25] = String.valueOf(storeInfos.get(i).getHomeFlag());
            dataList[i][26] = String.valueOf(storeInfos.get(i).getTypeFlag());
            dataList[i][27] = String.valueOf(storeInfos.get(i).getSubclass());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }
}

